<head>
  <!-- Load plotly.js into the DOM -->
  <!-- info page : https://plotly.com/javascript/plotlyjs-events/ -->
  <script src="https://cdn.plot.ly/plotly-2.14.0.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.17/d3.min.js"></script>
</head>

<body>
  <div id="timeDivPlotly">
    <!-- Plotly chart will be drawn inside this DIV -->
  </div>
  <div>
    <h4 id="actualInitDateId">actual initial date:</h4>
    <h4 id="actualEndDateId">actual end date:</h4>
    <button id="redesignBar" onclick="redesign">Redesign</button>
  </div>
  <div id="barDivPlotly">
    <!-- Plotly chart will be drawn inside this DIV -->
  </div>
</body>

<script>
  d3.csv(
    "https://raw.githubusercontent.com/plotly/datasets/master/finance-charts-apple.csv",
    function (err, rows) {
      function unpack(rows, key) {
        return rows.map(function (row) {
          return row[key];
        });
      }

      var trace1 = {
        type: "scatter",
        mode: "lines",
        name: "AAPL High",
        x: unpack(rows, "Date"),
        y: unpack(rows, "AAPL.High"),
        line: { color: "#17BECF" },
      };

      var trace2 = {
        type: "scatter",
        mode: "lines",
        name: "AAPL Low",
        x: unpack(rows, "Date"),
        y: unpack(rows, "AAPL.Low"),
        line: { color: "#7F7F7F" },
      };

      var data = [trace1, trace2];

      var layout = {
        title: "Time Series with Rangeslider",
        xaxis: {
          autorange: true,
          rangeselector: {
            buttons: [
              {
                count: 1,
                label: "1m",
                step: "month",
                stepmode: "backward",
              },
              {
                count: 6,
                label: "6m",
                step: "month",
                stepmode: "backward",
              },
              { step: "all" },
            ],
          },
          rangeslider: {},
          type: "date",
        },
        yaxis: {
          autorange: true,
          type: "linear",
        },
      };

      let h1ElementInit = document.getElementById("actualInitDateId");
      let h1ElementEnd = document.getElementById("actualEndDateId");

      Plotly.newPlot("timeDivPlotly", data, layout).then((myplotly) => {
        myplotly.on("plotly_relayout", function (eventdata) {
          if (
            Object.prototype.toString.call(eventdata["xaxis.range"]) ===
            "[object Array]"
          ) {
            console.log("----eventdata=", eventdata);
            console.log(
              "----myplotly rangeslider=",
              myplotly.layout.xaxis.rangeslider
            );
            console.log("------myplotly data=", myplotly.data);
            var x_start = eventdata["xaxis.range"][0];
            var x_end = eventdata["xaxis.range"][1];
            h1ElementInit.innerText = "actual initial date=" + x_start;
            h1ElementEnd.innerText = "actual end date=" + x_end;
            console.log(x_start + "----" + x_end);
          }
        });
        myplotly.on("plotly_restyle", function (eventdata) {
          console.log("----we have got a plotly_restyle event=", eventdata);
        });
      });
    }
  );

  var trace1 = {
    x: ["giraffes", "orangutans", "monkeys"],
    y: [20, 14, 23],
    name: "SF Zoo",
    type: "bar",
  };

  var trace2 = {
    x: ["giraffes", "orangutans", "monkeys"],
    y: [12, 18, 29],
    name: "LA Zoo",
    type: "bar",
  };

  var trace3 = {
    x: ["giraffes", "orangutans", "monkeys"],
    y: [12, 18, 29],
    name: "NY Zoo",
    type: "bar",
  };

  var data = [trace1, trace3,trace2];
  var layout = { barmode: "stack" };
  Plotly.newPlot("barDivPlotly", data, layout);
</script>
